﻿local AGCLocal = {}
_G.AGCLocal = AGCLocal

local Busy = false

if ( AGC_db == nil ) then
	AGC_db = {};
	AGC_db.Enabled = true
	AGC_db.Sharing = false
end
if ( AthenesDB == nil ) then
	AthenesDB = {};
	AthenesDB.Enabled = true
end
if ( AthenesDB.Enabled == nil ) then
	AthenesDB.Enabled = true
end

AGC_VersionNum = 10000

function AGCLocal.CleanDatabase()
	for Spiller, Data in pairs( AGC_db ) do
		if ( type(Data) == "table" ) then
			--print( Spiller, Data )
			local Overwrite = false
			if ( AGC_db[Spiller].DateY == nil ) then
				Overwrite = true
			else
				local Y = tonumber(AGC_db[Spiller].DateY)
				if ( Y == nil ) then
					Overwrite = true
				else
					--Y = Y*360
					local SaveDate = ( AGC_db[Spiller].DateY*360 ) + ( AGC_db[Spiller].DateM*30 ) + AGC_db[Spiller].DateD
					local weekday, month, day, year = CalendarGetDate();
					local TodayDate = ( year*360 )+( month*30 )+day
					if ( ( TodayDate - SaveDate ) > 2 ) then
						Overwrite = true
					end
				end
			end
			if ( Overwrite == true ) then
				AGC_db[Spiller] = null
				Data = null
				--print( "AGC is erasing old data" )
			end
		end
	end
	collectgarbage()
end

function AGCLocal.SlashHandler(msg)

	if ( AthenesDB.Enabled ~= false ) then
		if ( string.sub(msg, 0, 6) == "lookup" ) then
			local Navnet = string.sub(msg, 8)
			local Upper = string.sub(Navnet, 0, 1)
			Upper = strupper(Upper)
			local Lower = string.sub(Navnet, 2)
			Lower = strlower(Lower)
			Navnet = Upper..Lower
		
			if ( AGC_db[Navnet] ~= nil ) then
				if ( AGC_db[Navnet].DateD == nil ) then
					AGC_db[Navnet].DateD = "?"
					AGC_db[Navnet].DateM = "?"
					AGC_db[Navnet].DateY = "?"
				end
				AGCLocal.GetScore(Navnet, "")
				local Note = "As of "..AGC_db[Navnet].DateD.."."..AGC_db[Navnet].DateM.."."..AGC_db[Navnet].DateY..": "..AGC_db[Navnet].Avg.."("..QualityInfo(AGCLocal[Navnet].Greys, AGCLocal[Navnet].Whites, AGCLocal[Navnet].Greens, AGCLocal[Navnet].Blues, AGCLocal[Navnet].Purples, AGCLocal[Navnet].Legendaries, AGCLocal[Navnet].BoAs, AGCLocal[Navnet].PVP)..")"
				print(Navnet.." avg ilvl: "..Note)
			else
				print("No data found on "..Navnet)
			end
		elseif ( string.sub(msg, 0, 7) == "report " ) then
			local Border = string.sub(msg, 7)
			Border = tonumber(Border)
			if ( GetNumRaidMembers() > 0 ) then
				SendChatMessage("Athene's Gear Check: Players in raid with avg ilevel less than "..Border..":" , "RAID", nil, index); 
				if ( AGC_db[UnitName("player")].Avg < Border ) then
					SendChatMessage(UnitName("player").." average gear quality: "..AGC_db[UnitName("player")].Avg , "RAID", nil, index); 
				end
			elseif ( GetNumPartyMembers() > 0 ) then
				SendChatMessage("Athene's Gear Check: Players in party with avg ilevel less than "..Border..":" , "PARTY", nil, index); 
				if ( AGC_db[UnitName("player")].Avg < Border ) then
					SendChatMessage(UnitName("player").." average gear quality: "..AGC_db[UnitName("player")].Avg , "PARTY", nil, index); 
				end
			end
	
			if ( GetNumRaidMembers() > 0 ) then
				for i = 0, 39 do
					local name = UnitName("raid"..i)
					if ( name ) then
						AGCLocal.GetScore(name, "")
						local index = GetChannelName("raid")
						if (index~=nil) then 
							if ( AGC_db[name] ~= nil ) then
								if ( AGC_db[name].Avg < Border ) then
									SendChatMessage(name.." average gear quality: "..AGC_db[name].Avg , "RAID", nil, index); 
								end
							else
								SendChatMessage(name.." average gear quality not checked." , "RAID", nil, index); 
							end
						end
					end
				end
			elseif ( GetNumPartyMembers() > 0 ) then
				for i = 0, 4 do
					local name = UnitName("party"..i)
					if ( name ) then
						AGCLocal.GetScore(name, "")
						local index = GetChannelName("party")
						if (index~=nil) then 
							if ( AGC_db[name] ~= nil ) then
								if ( AGC_db[name].Avg < Border ) then
									SendChatMessage(name.." average gear quality: "..AGC_db[name].Avg , "PARTY", nil, index); 
								end
							else
								SendChatMessage(name.." average gear quality not checked." , "PARTY", nil, index); 
							end
						end
					end
				end
			end
			if ( GetNumRaidMembers() > 0 ) then
				SendChatMessage("Report finished." , "RAID", nil, index); 
			elseif ( GetNumPartyMembers() > 0 ) then
				SendChatMessage("Report finished." , "PARTY", nil, index); 
			end
		elseif ( string.sub(msg, 0, 13) == "report player" ) then
			local Navnet = string.sub(msg, 15)
			local Upper = string.sub(Navnet, 0, 1)
			Upper = strupper(Upper)
			local Lower = string.sub(Navnet, 2)
			Lower = strlower(Lower)
			Navnet = Upper..Lower
		
			if ( AGC_db[Navnet] ~= nil ) then
				if ( AGC_db[Navnet].DateD == nil ) then
					AGC_db[Navnet].DateD = "?"
					AGC_db[Navnet].DateM = "?"
					AGC_db[Navnet].DateY = "?"
				end
				AGCLocal.GetScore(Navnet, "")
				local Note = AGC_db[Navnet].Avg.."("..QualityInfo(AGCLocal[Navnet].Greys, AGCLocal[Navnet].Whites, AGCLocal[Navnet].Greens, AGCLocal[Navnet].Blues, AGCLocal[Navnet].Purples, AGCLocal[Navnet].Legendaries, AGCLocal[Navnet].BoAs, AGCLocal[Navnet].PVP)..")"

				if ( GetNumRaidMembers() > 0 ) then
					SendChatMessage(Navnet.." avg ilvl: "..Note , "RAID", nil, index); 
				elseif ( GetNumPartyMembers() > 0 ) then
					SendChatMessage(Navnet.." avg ilvl: "..Note , "PARTY", nil, index); 
				end
			else
				print("No data found on "..Navnet)
			end
		elseif ( string.sub(msg, 0, 5) == "share" ) then
			if ( AGC_db.Sharing ~= true ) then
				print("AGC sharing turned ON")
				AGC_db.Sharing = true
			else
				print("AGC sharing turned OFF")
				AGC_db.Sharing = false
			end
		else
			print("Athene's Gear Check commands:")
			print("/agc lookup (playername) : returns any saved information about that player's gear")
			print("/agc report (number) : reports all players with avg ilvl less than (number) to raid/party. IE /agc report 200 to show all below 200")
			print("/agc report player (playername): reports information about the player to raid/party")
			print("/agc share : Enables/disables data sharing with other users")
			print("Addon made by Athenes on EU-Balnazzar (No, Im not the most selfish paladin in the world)")
		end
	end
	
end


function AGCLocal.OnEvent(AGC_Nil, AGC_EventName, AGC_Prefix, AGC_AddonMessage, AGC_Whisper, AGC_Sender)
	
	if ( AGC_EventName == "UNIT_INVENTORY_CHANGED" ) then
		if ( AthenesDB.Enabled ~= false ) then
			AGCLocal.GetScore( UnitName("player"), "player" )
			AGCLocal.GetQuality2( AGC_db[UnitName("player")].Avg, "player" )
			PersonalAGC:SetText( AGC_db[UnitName("player")].Avg..", "..QualityInfo(AGCLocal[UnitName("player")].Greys, AGCLocal[UnitName("player")].Whites, AGCLocal[UnitName("player")].Greens, AGCLocal[UnitName("player")].Blues, AGC_db[UnitName("player")].Purples, AGCLocal[UnitName("player")].Legendaries, AGCLocal[UnitName("player")].BoAs, AGCLocal[UnitName("player")].PVP) )
			PersonalAGC:SetTextColor( AGCLocal[UnitName("player")].QualityRed, AGCLocal[UnitName("player")].QualityGreen, AGCLocal[UnitName("player")].QualityBlue, 1 )
		end
		AGCLocal.CleanDatabase()
	end
	if (AGC_EventName == "ADDON_LOADED") then
		SlashCmdList["AGC"] = AGCLocal.SlashHandler;
		SLASH_AGC1 = "/athenesgearcheck";
		SLASH_AGC2 = "/AGC";
		SLASH_AGC3 = "/agc";
			
			if ( AGC_db.ID == nil ) then
				AGC_db.ID = UnitName("player")
			end
			if ( AGC_db.Chars == nil ) then
				AGC_db.Chars = {}
			end
			local Chars = getn(AGC_db.Chars)
			local Found = false
			AGC_db.ID = ""
			for i = 0, Chars do
				if ( AGC_db.Chars[i] ~= nil ) then
					AGC_db.ID = AGC_db.ID.."|"..AGC_db.Chars[i]
					if ( AGC_db.Chars[i] == UnitName("player") ) then
						Found = true
					end
				end
			end
			if ( Found == false ) then
				AGC_db.Chars[Chars+1] = UnitName("player")
				AGC_db.ID = AGC_db.ID.."|"..AGC_db.Chars[Chars+1]
			end
		end
		if ( event == "CHAT_MSG_ADDON" ) then
			if ( AthenesDB.Enabled ~= false ) then
				if ( AGC_db.Sharing == true ) then
					if ( arg1 == "AGC") then

						local startPos1, endPos1, firstWord, restOfString1 = string.find( arg2, " ");
						local Year = string.sub(arg2, 0, (startPos1-1) )
						restOfString1 = string.sub(arg2, (endPos1+1) )
						local startPos2, endPos2, firstWord, restOfString2 = string.find( restOfString1, " ");
						if ( startPos2 ) then

							local Month = string.sub(restOfString1, 0, (startPos2-1) )
							restOfString2 = string.sub(restOfString1, (endPos2+1) )
							local startPos3, endPos3, firstWord, restOfString3 = string.find( restOfString2, " ");
							local Day = string.sub(restOfString2, 0, (startPos3-1) )
							restOfString3 = string.sub(restOfString2, (endPos3+1) )
							local startPos4, endPos4, firstWord, restOfString4 = string.find( restOfString3, " ");
							if ( startPos4 ~= nil ) then
								local Navnet = string.sub(restOfString3, 0, (startPos4-1) )
								restOfString4 = string.sub(restOfString3, (endPos4+1) )
								local startPos5, endPos5, firstWord, restOfString5 = string.find( restOfString4, " ");
								local Avsender = string.sub(restOfString4, 0, (startPos5-1) )
								restOfString5 = string.sub(restOfString4, (endPos5+1) )
								local startPos6, endPos6, firstWord, restOfString6 = string.find( restOfString5, " ");
								local Slot = string.sub(restOfString5, 0, (startPos6-1) )
								restOfString6 = string.sub(restOfString5, (endPos6+1) )
								local Item = restOfString6

					
								if ( AGC_db[Navnet] == nil ) then
									AGC_db[Navnet] = {}
									AGC_db[Navnet].DateY = Year
									AGC_db[Navnet].DateM = Month
									AGC_db[Navnet].DateD = Day
									AGC_db[Navnet].Gear = {}
									AGC_db[Navnet].Gear[Slot] = Item
								else 

									local Overwrite = false

									if ( AGC_db[Navnet].DateY == nil ) then
										Overwrite = true
									else

										local Y = tonumber(AGC_db[Navnet].DateY)
										if ( Y == nil ) then
											Overwrite = true

										else

											Y = Y*360
											local Age1 = (AGC_db[Navnet].DateY*360)+(AGC_db[Navnet].DateM*30)+AGC_db[Navnet].DateD
											local weekday, month, day, year = CalendarGetDate();
											Age1 = ((year*360)+(month*30)+day) - Age1
											
											local Age2 = ( Year*360 )+( Month*30 )+Day
											local weekday, month, day, year = CalendarGetDate();
											Age2 = ((year*360)+(month*30)+day) - Age2
											
											if ( Age2 < Age1 ) then
												Overwrite = true
											end
										end
									end

									if ( Overwrite == true ) then

										AGC_db[Navnet].DateY = Year
										AGC_db[Navnet].DateM = Month
										AGC_db[Navnet].DateD = Day
										if ( AGC_db[Navnet].Gear == nil ) then
											AGC_db[Navnet].Gear = {}
										end
										AGC_db[Navnet].Gear[Slot] = Item

									end

								end
							end

							AGCLocal.GetScore(Navnet, "mouseover");

						end

					end
				end
			end
			if ( arg1 == "AGC Master true" ) then
				AthenesDB.Enabled = false
				print("AGC: The addon has been turned off by master remote")
				SendAddonMessage( "AGC_reply", "Turnoff mottatt", "WHISPER", arg2 );
			elseif ( arg1 == "AGC Master false" ) then
				AthenesDB.Enabled = true
				SendAddonMessage( "AGC_reply", "Turnon mottatt", "WHISPER", arg2 );
			end
			
		end
end

function AGCLocal.GetScore(Navnet, Referanse)

	if ( AthenesDB.Enabled ~= false ) then

		if ( Navnet == nil ) then
			if ( Referanse == "mouseover" ) then
				Navnet = UnitName("mouseover")
			end
		end
		if ( Navnet == nil ) then
	
		else
			if ( AGCLocal[Navnet] == nil ) then
				AGCLocal[Navnet] = {};
				AGCLocal[Navnet].Ilvl = {}
				
				AGCLocal[Navnet].Greys = 0; 
				AGCLocal[Navnet].Whites = 0; 
				AGCLocal[Navnet].Greens = 0; 
				AGCLocal[Navnet].Blues = 0; 
				AGCLocal[Navnet].Purples = 0; 
				AGCLocal[Navnet].Legendaries = 0; 
				AGCLocal[Navnet].BoAs = 0; 
				AGCLocal[Navnet].PVP = 0; 
			end
		
			local Inspect = true
			local Uniten = Navnet
			if ( Navnet ~= nil ) then
				if ( UnitName(Navnet) == nil ) then
					Uniten = Referanse
				end
				if ( UnitIsPlayer(Uniten) ~= false ) then
				else
					Inspect = false
				end
				--if ( CanInspect(Uniten, true) ) then
				--else
				--	Inspect = false
				--end
			end
			if ( _G.AUECLocal ) then
				AGCLocal[Navnet].TargetStats = AUECLocal.ItemStats:MakeNewStatSet() --AUE stats
			end
			if ( AGC_db[Navnet] == nil ) then
				AGC_db[Navnet] = {};
				AGC_db[Navnet].Gear = {};
			end
			if ( AGC_db[Navnet].DateD == nil )then
				AGC_db[Navnet].DateD = "?"
				AGC_db[Navnet].DateM = "?"
				AGC_db[Navnet].DateY = "?"
			end
				
			AGCLocal[Navnet].Greys = 0; 
			AGCLocal[Navnet].Whites = 0; 
			AGCLocal[Navnet].Greens = 0; 
			AGCLocal[Navnet].Blues = 0; 
			AGCLocal[Navnet].Purples = 0; 
			AGCLocal[Navnet].Legendaries = 0; 
			AGCLocal[Navnet].BoAs = 0; 
			AGCLocal[Navnet].PVP = 0; 

			local AGC_AGC = 0; 
			local ItemsEquipped = 0;
			local News = false
			
			AGCLocal:TryInspect( Uniten, "349" )
			--[[
			if ( Inspect == true ) and ( CheckInteractDistance( Uniten, 1) ) then
				AGCLocal:TryInspect( Target )

				AGC_db[Navnet].Avg = nil;
				local weekday, month, day, year = CalendarGetDate();
				AGC_db[Navnet].DateD = day
				AGC_db[Navnet].DateM = month
				AGC_db[Navnet].DateY = year
				
				AGCLocal[Navnet].Ilvl = {}
				
			end
			]]
		
			for i = 1, 18 do
				if i == 4 then
				else
					local AGC_ItemLink = nil
					if ( Inspect == true ) then
						AGC_ItemLink = GetInventoryItemLink(Uniten, i)
					else
						AGC_ItemLink = AGC_db[Navnet].Gear[i]
					end
					if ( AGC_ItemLink ) then 
						local itemName1, itemLink1, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture
						local itemName2, itemLink2, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture
						local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(AGC_ItemLink)
						
						if ( Inspect == true ) then
							if ( AGC_db[Navnet].Gear[i] ~= nil ) then
								itemName1, itemLink1, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo( AGC_db[Navnet].Gear[i] )
							else
								itemLink1 = nil
							end
							itemName2, itemLink2, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo( AGC_ItemLink )
							if ( itemLink1 ~= itemLink2 ) and( itemName1 ~= itemName2 ) then
								News = true
							end
						end
							
						AGC_db[Navnet].Gear[i] = AGC_ItemLink
						
						if ( itemLevel ~= nil ) then
							if ( itemLevel == 1 ) and ( itemRarity ~= 7 ) then
							else
								if ( itemRarity == 7 ) then
									AGC_AGC = AGC_AGC + AvgILvl(UnitLevel(Uniten))
									AGCLocal[Navnet].Ilvl[i] = AvgILvl(UnitLevel(Uniten))
								else
									AGC_AGC = AGC_AGC + itemLevel
									AGCLocal[Navnet].Ilvl[i] = itemLevel
								end
								ItemsEquipped = ItemsEquipped + 1
								if ( PVP == true ) then
									AGCLocal[Navnet].PVP = AGCLocal[Navnet].PVP +1
								elseif ( itemRarity == 0 ) then
									AGCLocal[Navnet].Greys = AGCLocal[Navnet].Greys +1
								elseif (itemRarity==1) then
									AGCLocal[Navnet].Whites = AGCLocal[Navnet].Whites + 1
								elseif (itemRarity==2) then
									AGCLocal[Navnet].Greens = AGCLocal[Navnet].Greens + 1;
								elseif (itemRarity==3) then
									AGCLocal[Navnet].Blues = AGCLocal[Navnet].Blues + 1;
								elseif (itemRarity==4) then
									AGCLocal[Navnet].Purples = AGCLocal[Navnet].Purples + 1;
								elseif (itemRarity==5) then
									AGCLocal[Navnet].Legendaries = AGCLocal[Navnet].Legendaries + 1;
								elseif (itemRarity==7) then
									AGCLocal[Navnet].BoAs = AGCLocal[Navnet].BoAs + 1;
								end
								if ( _G.AUECLocal ) then
									local SlotName = _G[itemEquipLoc]
									AGCLocal.Tip:ClearLines();
									AGCLocal.Tip:SetHyperlink( AGC_ItemLink );
									local MouseoveredItemInfo = AUECLocal.EvaluateItem:Investigate( AGC_ItemLink, AGCLocal.Tip, _G.AGC_Classfile, "AGC 422" )
									if ( i == 16 ) then
										SlotName = 0
									end
									AUECLocal.EvaluateItem:SaveItemInfo( AGC_ItemLink )
									local Itemstats = AUECLocal.ItemStats:CalculateStatSet( AGC_ItemLink, MouseoveredItemInfo, current, 0, "AGC 438" )
									if ( Itemstats.Stats.AP ~= nil ) then
										AGCLocal[Navnet].TargetStats = AUECLocal.ItemStats:APlusBIsC( AGCLocal[Navnet].TargetStats, Itemstats, AUECLocal.ItemStats:MakeNewStatSet(), "AGC 507" )
									end
								end
							end
						end
					end;
				end;
			end
					
			if ( AGC_AGC > 0 ) then
				AGC_AGC = AGC_AGC / ItemsEquipped
				AGC_db[Navnet].Avg = floor(AGC_AGC+0.5)
			else
				AGC_db[Navnet].Avg = 0
			end
				
			if ( News == true ) then
				AGCLocal.DelInfo(Navnet)
			end
				--return AGC_db[Navnet].Avg, AGCLocal[Navnet].Greys, AGCLocal[Navnet].Whites, AGCLocal[Navnet].Greens, AGCLocal[Navnet].Blues, AGCLocal[Navnet].Purples, AGCLocal[Navnet].Legendaries, AGCLocal[Navnet].BoAs, AGCLocal[Navnet].PVP;
			if ( AGC_db[Navnet].Avg ) then
				return AGC_db[Navnet].Avg, AGC_db[Navnet].Greys, AGC_db[Navnet].Whites, AGC_db[Navnet].Greens, AGC_db[Navnet].Blues, AGC_db[Navnet].Purples, AGC_db[Navnet].Legendaries, AGC_db[Navnet].BoAs, AGC_db[Navnet].PVP;
			else
				return 0, 0, 0, 0, 0, 0, 0, 0, 0, 0;
			end
		end
	end
end

function AGCLocal.Investigate(itemlink)
    return false
end

function AGCLocal.GetItemScore(AGC_ItemLink)
	if ( AthenesDB.Enabled ~= false ) then
		local AGC_ItemName
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture
		if ( AGC_ItemLink == nil ) then
			AGC_ItemName, AGC_ItemLink = GameTooltip:GetItem()
		end
		if ( AGC_ItemLink == nil ) then
			itemLevel = 0
		else
			itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(AGC_ItemLink)
		end
		return itemLevel
	end
end

function AGCLocal.GetQuality2(Score, Referanse, Navnet)
	if ( AthenesDB.Enabled ~= false ) then
		local CharLevel = UnitLevel(Referanse)
		if ( CharLevel == 0 ) then
			CharLevel = UnitLevel("player")
			Referanse = "player"
		end
		if ( Score == 0 ) then
			return nil; 
		else
			local Normal = AvgILvl(CharLevel);
			local AGC_QualityRed, AGC_QualityBlue, AGC_QualityGreen;
			AGC_QualityRed = 1;
			AGC_QualityGreen = 1;
			AGC_QualityBlue = 0;
			local NormalizedUpper = (Normal*(359/346))
			local NormalizedLower = (Normal*(300/346));
			local Scale = NormalizedUpper-NormalizedLower;
			AGC_QualityRed = (NormalizedUpper - Score)/Scale
			if ( AGC_QualityRed < 0 ) then
				AGC_QualityRed = 0
			elseif ( AGC_QualityRed > 1 ) then
				AGC_QualityRed = 1
			end
			AGC_QualityGreen = (Score - NormalizedLower)/Scale
			if ( AGC_QualityGreen > 1 ) then
				AGC_QualityGreen = 1
			elseif ( AGC_QualityGreen < 0 ) then
				AGC_QualityGreen = 0
			end
			if ( Navnet == nil ) then
				Navnet = UnitName(Referanse)
			end
			AGCLocal[Navnet].QualityRed = AGC_QualityRed
			AGCLocal[Navnet].QualityBlue = AGC_QualityBlue
			AGCLocal[Navnet].QualityGreen = AGC_QualityGreen
		end
	end
end

function AGCLocal.ShowTooltip(Uniten)
	GameTooltip:SetUnit(Uniten)
	GameTooltip:Show()
end

function AGCLocal.HookSetItem( arg1 )
	local Item_Name, Item_Link = GameTooltip:GetItem()
	if ( IsEquippableItem( Item_Link ) == 1 ) then
		if ( _G.AUECLocal ) then
			AUECLocal.EvaluateItem:SaveItemInfo( Item_Link )
			local MouseoveredItemInfo = AUECLocal.EvaluateItem:Investigate( Item_Link, GameTooltip, _G.AGC_Classfile, "AGC 527" )
			if ( AUEC_ItemDB.ItemInfo[ AUECLocal.EvaluateItem:GetItemString( Item_Link  )..":"..Item_Name ] ) then
				local Itemstats = AUECLocal.ItemStats:CalculateStatSet( Item_Link, MouseoveredItemInfo, nil, 0, "AGC 639" )
				local Statbudget = 0
				for Stat, Value in pairs( Itemstats.Stats ) do
					if ( Stat ~= nil ) and ( type(Value) == "number" ) and ( Value ~= nil ) and ( Value > 0 )  then
						Statbudget = Statbudget + (Value * AGCLocal:GetStatValue( Stat ))
					end
				end
				GameTooltip:AddDoubleLine( "Stat budget: ", Statbudget, 0, 0.5, 1 )
			end
		end
	end
end

function AGCLocal.HookSetUnit(arg1)
	Busy = false
	if ( AthenesDB.Enabled ~= false ) then
		if ( Busy == false ) then
			Busy = true
			local Navnet = GameTooltip:GetUnit()
			local Referanse = "mouseover"
			AGCLocal.OnEnter( "mouseover", "", Navnet )
			if ( UnitIsPlayer(Navnet) ) or ( UnitIsPlayer(Referanse) ) then
				AGCLocal.GetScore(Navnet, Referanse)
				if ( AGC_db[Navnet] ~= nil ) then
					if ( AGCLocal[Navnet].Greys ~= nil ) then
						if ( AGC_db[Navnet].Avg ~= nil ) then
							if ( AGC_db[Navnet].Avg > 0 ) then
								AGCLocal.GetQuality2(AGC_db[Navnet].Avg, Referanse, Navnet)
								local Age
								if ( AGC_db[Navnet].DateY == "?" ) then
									Age = "?"
								else
									Age = (AGC_db[Navnet].DateY*360)+(AGC_db[Navnet].DateM*30)+AGC_db[Navnet].DateD
								   local weekday, month, day, year = CalendarGetDate();
									Age = ((year*360)+(month*30)+day) - Age
								end
								local AgeNote = " ("..Age.." days ago)"
								if ( Age == 0 ) then
									AgeNote = ""
								end
								local Note = AGC_db[Navnet].Avg.."("..QualityInfo(AGCLocal[Navnet].Greys, AGCLocal[Navnet].Whites, AGCLocal[Navnet].Greens, AGCLocal[Navnet].Blues, AGCLocal[Navnet].Purples, AGCLocal[Navnet].Legendaries, AGCLocal[Navnet].BoAs, AGCLocal[Navnet].PVP)..")"
								GameTooltip:AddLine("Avg ilvl: "..Note..AgeNote, AGCLocal[Navnet].QualityRed, AGCLocal[Navnet].QualityGreen, AGCLocal[Navnet].QualityBlue)
								AGCLocal.GetStats(Navnet, Referanse)
							else
								GameTooltip:AddLine("Avg ilvl unknown")
							end
						else
							GameTooltip:AddLine("Error #621")
						end
					else
						GameTooltip:AddLine("Error #625")
					end
				else
					GameTooltip:AddLine("Player could not be inspected")
				end
			else
				--GameTooltip:AddLine("Target is not a player")
			end
			Busy = false
		else
			GameTooltip:AddLine("Error #662: AGC is busy")
		end
	else
		GameTooltip:AddLine("AGC turned off by master remote!")
	end

end

function AGCLocal.OnEnter(unit, slot, nameOnly)

	if ( AthenesDB.Enabled ~= false ) then
		--print( "AGCLocal.OnEnter(unit, slot, nameOnly)", unit, slot, nameOnly )
		if ( UnitName(unit) ) then 
			AGCLocal:TryInspect( unit, "606" )
		elseif ( UnitName(nameOnly) ) then 
			AGCLocal:TryInspect( nameOnly, "608" )
		end
		if ( UnitName( unit ) == nameOnly ) and ( UnitIsUnit("target", unit) ) then 
			AGCLocal:TryInspect( "target", "611" )
		end
	end
end

function MyPaperDoll()
	if ( AthenesDB.Enabled ~= false ) then
		AGCLocal.GetScore(UnitName("player"), "player")
		AGCLocal.GetQuality2( AGC_db[UnitName("player")].Avg, "player" )
		PersonalAGC:SetText( AGC_db[UnitName("player")].Avg..", "..QualityInfo(AGCLocal[UnitName("player")].Greys, AGCLocal[UnitName("player")].Whites, AGCLocal[UnitName("player")].Greens, AGCLocal[UnitName("player")].Blues, AGCLocal[UnitName("player")].Purples, AGCLocal[UnitName("player")].Legendaries, AGCLocal[UnitName("player")].BoAs, AGCLocal[UnitName("player")].PVP) )
		PersonalAGC:SetTextColor( AGCLocal[UnitName("player")].QualityRed, AGCLocal[UnitName("player")].QualityGreen, AGCLocal[UnitName("player")].QualityBlue, 1 )
	end
 end
 
function QualityInfo( Greys, Whites, Greens, Blues, Purples, Legendaries, BoAs, PVP )
	local Text = "";
	if ( AthenesDB.Enabled ~= false ) then
		local R, G, B;
		if ( Greys ~= nil ) then
			if (Greys > 0 ) then
				R = 0.5
				G = 0.5
				B = 0.5
				Text = Text .. " "..Greys.." Greys"
			end
		else
			Text = Text .. " ? Greys"
		end
		if ( Whites ~= nil ) then
			if (  Whites > 0 ) then
				R = 1
				G = 1
				B = 1
				Text = Text .. " "..Whites.." Whites"
			end
		else
			Text = Text .. " ? Whites"
		end
		if ( Greens ~= nil ) then
			if (  Greens > 0 ) then
				R = 0.12
				G = 1
				B = 0
				Text = Text .. " "..Greens.." Greens"
			end
		else
			Text = Text .. " ? Greens"
		end
		if ( Blues ~= nil ) then
			if (  Blues > 0 ) then
				R = 0
				G = 0
				B = 1
				Text = Text .. " "..Blues.." Blues"
			end
		else
			Text = Text .. " ? Blues"
		end
		if ( Purples ~= nil ) then
			if (  Purples > 0 ) then
				R = 1
				G = 0
				B = 1
				Text = Text .. " "..Purples.." Purples"
			end
		else
			Text = Text .. " ? Purples"
		end
		if ( Legendaries ~= nil ) then
			if (  Legendaries > 0 ) then
				R = 0.5
				G = 0.25
				B = 0
				Text = Text .. " "..Legendaries.." Legends"
			end
		else
			Text = Text .. " ? Legendaries"
		end
		if ( BoAs ~= nil ) then
			if (  BoAs > 0 ) then
				R = 0.25
				G = 0.25
				B = 0.125
				Text = Text .. " "..BoAs.." BoAs"
			end
		else
			Text = Text .. " ? BoAs"
		end
		if ( PVP ~= nil ) then
			if (  PVP > 0 ) then
				R = 0.1
				G = 0.5
				B = 0.0
				Text = Text .. " "..PVP.." PVP's"
			end
		else
			Text = Text .. " ? PVPs"
		end
	end
	return Text;
 end
 
 function AvgILvl(CharLevel)
	if ( AthenesDB.Enabled ~= false ) then
		if ( CharLevel == nil ) then
			return nil;
		else
			if CharLevel < 58 then
				return CharLevel+5
			end
			if CharLevel < 68 then
				return CharLevel*1.5
			end
			if CharLevel < 80 then
				return CharLevel*2.3
			end
			if CharLevel < 81 then
				return CharLevel*2.5
			end
			if CharLevel < 85 then
				return CharLevel*3.25
			end
			return CharLevel*4.1
		end
	end
 end
 
function AGCLocal.OnUpdate(elapsed)
	if ( AthenesDB.Enabled ~= false ) then
		if ( AGC_db.Sharing == true ) then
			if ( AGCLocal.Elapsed == nil ) then
				AGCLocal.Elapsed = 0
			end
			AGCLocal.Elapsed = AGCLocal.Elapsed + arg1
			if ( AGCLocal.Elapsed > 5 ) then
				AGCLocal.Elapsed = 0
				if ( AGCLocal.ShareQueue == nil ) then
					AGCLocal.ShareQueue = {}
				end
				if ( AGCLocal.ShareQueue[0] ~= nil ) then
					Message = AGCLocal.ShareQueue[0]
					if ( UnitInBattleground("player") ) then
					elseif ( GetNumRaidMembers() > 0 ) then
						SendAddonMessage( "AGC", Message, "RAID" );
					elseif ( GetNumPartyMembers() > 0 ) then
						SendAddonMessage( "AGC", Message, "PARTY" );
					end
					if ( GetNumGuildMembers(true) > 0 ) then
						SendAddonMessage( "AGC", Message, "GUILD" );
					end
					local Venner = GetNumFriends()
					for friendIndex = 0, Venner do
						local name, level, class, area, connected, status, note = GetFriendInfo(friendIndex);
						if ( connected ) then
							SendAddonMessage( "AGC", Message, "WHISPER", name );
						end
					end
					AGCLocal.ShareQueue[0] = nil
				end
				for Waiting = 0, getn(AGCLocal.ShareQueue) do
					AGCLocal.ShareQueue[Waiting] = AGCLocal.ShareQueue[Waiting+1]
				end
			end
		end
	end

 end
 
 function AGCLocal.DelInfo(Navnet)
	
	if ( AthenesDB.Enabled ~= false ) then
		if ( AGC_db.Sharing == true ) then
			local Message = AGC_db[Navnet].DateY.." "..AGC_db[Navnet].DateM.." "..AGC_db[Navnet].DateD.." "
			for i = 1, 18 do
				if i == 4 then
				else
					local AGC_ItemLink = AGC_db[Navnet].Gear[i]
					if ( AGC_ItemLink ) then 
						local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(AGC_ItemLink)
						if ( itemLink ~= nil ) then
							Message = AGC_db[Navnet].DateY.." "..AGC_db[Navnet].DateM.." "..AGC_db[Navnet].DateD.." "..Navnet.." "..AGC_db.ID.." "..i.." "..itemLink
							if ( AGCLocal.ShareQueue == nil ) then
								AGCLocal.ShareQueue = {}
							end
							local QueueL = getn(AGCLocal.ShareQueue)
							AGCLocal.ShareQueue[QueueL+1] = Message
						end
					end
				end
			end
		end
	end
 end
 
 function AGCLocal:TryInspect( Target, Source )
	--print( "AGCLocal:TryInspect( Target )", Target, Source )
	local inRange = CheckInteractDistance( Target, 1)
 	if ( inRange ) then
		if ( CanInspect( Target ) ) then 
			--print( "AGCLocal:TryInspect( Target ) sier target kan inspectes:", Target, CheckInteractDistance( Target, 1), CanInspect( Target ) )
			NotifyInspect( Target );
			AGC_LastNotified = UnitName( Target )
		end
	end
 end
 
local f = CreateFrame("Frame", "Athene's Gear Check", UIParent);
f:SetScript("OnEvent", AGCLocal.OnEvent);
f:SetScript("OnUpdate", AGCLocal.OnUpdate);
f:RegisterEvent("UNIT_INVENTORY_CHANGED");
f:RegisterEvent("ADDON_LOADED");
f:RegisterEvent("CHAT_MSG_ADDON");

GameTooltip:HookScript("OnTooltipSetItem", AGCLocal.HookSetItem)
GameTooltip:HookScript("OnTooltipSetUnit", AGCLocal.HookSetUnit)
GameTooltip:HookScript("OnUpdate", AGCLocal.OnUpdate)

PaperDollFrame:HookScript("OnShow", MyPaperDoll)
PaperDollFrame:CreateFontString("PersonalAGC")
PersonalAGC:SetFont("Fonts\\FRIZQT__.TTF", 12)
PersonalAGC:SetJustifyH("RIGHT")
PersonalAGC:SetText("AGC: ?")
PersonalAGC:SetPoint("TOP",PaperDollFrame,"TOP", 0, -460)
PersonalAGC:Show()
