local AGCLocal = _G.AGCLocal

AGCLocal.Tip = AGCLocal.Tip or CreateFrame("GameTooltip","AGCLocalTip",nil,"GameTooltipTemplate");
AGCLocal.Tip:SetOwner(UIParent,"ANCHOR_NONE");

local TargetStats = 0

_G.AGC_Classfile = nil
_G.AGC_TargetClass = nil
local AbilityPotentials = {}
_G.RaidTalents = {}
if ( AGC_db.SavedSpeccs == nil ) then
	AGC_db.SavedSpeccs = {}
end

function AGCLocal.SetupClass(Navnet, Referanse)
	_G.AGC_TargetClass, _ = UnitClass(Navnet)
	if ( _G.AGC_TargetClass ) then
	else
		_G.AGC_TargetClass, _ = UnitClass(Referanse)
	end
		if ( strlower(_G.AGC_TargetClass) == strlower("Death Knight") ) then
			_G.AGC_Classfile = _G.AUECLocal.DK
		elseif ( strlower(_G.AGC_TargetClass) == strlower("Druid") ) then
			_G.AGC_Classfile = _G.AUECLocal.Druid
		elseif ( strlower(_G.AGC_TargetClass) == strlower("Hunter") ) then
			_G.AGC_Classfile = _G.AUECLocal.Hunter
		elseif ( strlower(_G.AGC_TargetClass) == strlower("Mage") ) then
			_G.AGC_Classfile = _G.AUECLocal.Mage
		elseif ( strlower(_G.AGC_TargetClass) == strlower("Paladin") ) then
			_G.AGC_Classfile = _G.AUECLocal.Paladin
		elseif ( strlower(_G.AGC_TargetClass) == strlower("Priest") ) then
			_G.AGC_Classfile = _G.AUECLocal.Priest
		elseif ( strlower(_G.AGC_TargetClass) == strlower("Rogue") ) then
			_G.AGC_Classfile = _G.AUECLocal.Rogue
		elseif ( strlower(_G.AGC_TargetClass) == strlower("Shaman") ) then
			_G.AGC_Classfile = _G.AUECLocal.Shaman
		elseif ( strlower(_G.AGC_TargetClass) == strlower("Warlock") ) then
			_G.AGC_Classfile = _G.AUECLocal.Warlock
		elseif ( strlower(_G.AGC_TargetClass) == strlower("Warrior") ) then
			_G.AGC_Classfile = _G.AUECLocal.Warrior
		else
			print("- AGC stats error 46. Most likely cause: Plugin only supports english clients:", _G.AGC_TargetClass, A, _G.AGC_TargetClass, UnitClass(Navnet) )
			_G.AGC_Classfile = nil
		end
end

function AGCLocal.GetStats(Navnet, Referanse) -- kalles fra agc 640
	local UnitsLevel = 80
	if ( UnitAffectingCombat("player") ) then
		return
	end
	if ( _G.AUECLocal ) and ( AGCLocal[Navnet].TargetStats ) then
		--GameTooltip:AddDoubleLine( "AGC target stats:" )
		TargetStats = AUECLocal.ItemStats:APlusBIsC( AUECLocal.ItemStats:MakeNewStatSet(), AGCLocal[Navnet].TargetStats, TargetStats, "AGCLocal.GetStats" )
		if ( Navnet == nil ) then
			if ( Referanse == "mouseover" ) then
				Navnet = UnitName("mouseover")
				UnitsLevel = UnitLevel("mouseover")
			end
		else
			if ( Referanse == "mouseover" ) then
				UnitsLevel = UnitLevel("mouseover")
			end
			if ( UnitsLevel == 0 ) then
				UnitsLevel = UnitLevel(Navnet)
			end
		end
		if ( Navnet == nil ) then
			return
		end
		AGCLocal.SetupClass(Navnet, Referanse)
		if ( _G.AGC_TargetClass ) then
			--_G.LibTalent = LibStub:GetLibrary("LibTalentQuery-1.0")
			--_G.LibTalent.RegisterCallback(AGCLocal, "TalentQuery_Ready")
			--_G.LibTalent:Query(Navnet)
			
			if ( AUEC.SavedSpeccs ) and ( AUEC.SavedSpeccs[Navnet] ) then
				TargetStats = _G.AGC_Classfile:ApplyStatTalents( TargetStats, true, Navnet )
			end
			if ( TargetStats ~= nil ) then
				TargetStats = _G.AGC_Classfile:ConvertToCombatStats( TargetStats, true, Navnet, _G.AGC_Classfile )
			end
		end
		local DPS = 0
		if not AUEC_RotationDB.ActiveRotation then
			return
		end
		local OriginalRotation = AUEC_RotationDB.ActiveRotation[Navnet]
		local BestRotation = ""
		if ( _G.AGC_TargetClass ~= nil ) and ( TargetStats ~= nil ) then
			--[[
			_G.AGC_Classfile:CreateDPSSpells()
			if ( AUEC_RotationDB.Class[_G.AGC_TargetClass] ~= nil ) then
				for Name, Data in pairs( AUEC_RotationDB.Class[_G.AGC_TargetClass].Rotation ) do
					if ( strfind(Name, "default")) then
						AUEC_RotationDB.ActiveRotation[Navnet] = Name
						local Temp = AUECLocal.DPS:BeOmDPSBeregning( TargetStats, Navnet, _G.AGC_TargetClass, _G.AGC_Classfile, true,  85 )
						if ( Temp ) and ( type(Temp) == "number" ) and ( Temp > DPS ) then
							DPS = Temp
							BestRotation = Name
						end
					end
				end
			elseif ( AUEC_RotationDB.Class[_G.AGC_TargetClass] == nil ) then
				print( "ingen rotasjon for", _G.AGC_TargetClass )
			else
				print( "AGC:stats unknown error", AUEC_RotationDB.ActiveRotation[Navnet], AUEC_RotationDB.Class[_G.AGC_TargetClass] )
			end
			DPS = math.floor(DPS*10)/10
			AUEC_RotationDB.ActiveRotation[Navnet] = BestRotation
			if ( DPS == 0 ) then
			else
				GameTooltip:AddDoubleLine( "DPS estimate: ", DPS, 1,1,1  )
				GameTooltip:AddDoubleLine( "DPS rotation: ", AUEC_RotationDB.ActiveRotation[Navnet], 1,1,1  )
			end
			if ( OriginalRotation ~= nil ) then
				AUEC_RotationDB.ActiveRotation[Navnet] = OriginalRotation
			end
			]]
			local RatingPerHaste = 0
			local RatingPerCrit = 0
			local RatingPerMeleeHit = 0
			local RatingPerExp = 0
			local RatingPerMastery = 0
			local Statbudget = 0
			local Resilience = 0
			for Stat, Value in pairs( TargetStats.Stats ) do
				if ( Stat ~= nil ) and ( type(Value) == "number" ) and ( Value ~= nil ) and ( Value > 0 )  then
					--print( Stat, Value )
					if ( Stat == "Haste" ) then
						RatingPerHaste = AUECLocal.StatConversions:Haste_RatingToPercent ( TargetStats.Stats[Stat], UnitsLevel )
						TargetStats.Stats[Stat] = TargetStats.Stats[Stat] / RatingPerHaste
					end
					if ( Stat == "Crit" ) then
						RatingPerCrit = AUECLocal.StatConversions:Crit_RatingToPercent ( TargetStats.Stats[Stat], UnitsLevel )
						TargetStats.Stats[Stat] = TargetStats.Stats[Stat] / RatingPerCrit
					end
					if ( Stat == "Hit" ) then
						RatingPerMeleeHit = AUECLocal.StatConversions:Hit_RatingToPercent ( TargetStats.Stats[Stat], UnitsLevel, "melee" )
						TargetStats.Stats[Stat] = TargetStats.Stats[Stat] / RatingPerMeleeHit
					end
					if ( Stat == "Exprate" ) then
						RatingPerExp = AUECLocal.StatConversions:Exp_RatingToPercent ( TargetStats.Stats[Stat], UnitsLevel )
						if ( RatingPerExp == nil ) then
						else
							TargetStats.Stats[Stat] = TargetStats.Stats[Stat] / RatingPerExp
						end
					end
					if ( Stat == "Mastery" ) or ( Stat == "Masteryrating" ) then
						RatingPerMastery = AUECLocal.StatConversions:Mastery_RatingToPercent ( TargetStats.Stats[Stat], UnitsLevel, "melee" )
						TargetStats.Stats[Stat] = TargetStats.Stats[Stat] / RatingPerMastery
					end
					if ( Stat == "Resilience" ) then
						Resilience = Resilience + Value
					end
					Statbudget = Statbudget + (Value * AGCLocal:GetStatValue( Stat ))
				elseif ( type(Value) ~= "number" ) then
					TargetStats.Stats[Stat] = 0
				end
			end
			TargetStats = AUECLocal.ItemStats:CleanStats(TargetStats)
			local StatTypes = 0
			local StatsFilled = 0
			for Stat, Value in pairs( TargetStats.Stats ) do
				StatTypes = StatTypes + 1
				if ( Stat ~= nil ) and ( Value ~= nil ) and ( Value > 0 )  then
					local Add = true
					if ( Stat == "Armor" ) then
						Add = false
					elseif ( Stat == "Stamina" ) then
						Add = false
					end
					if ( Stat == "Haste" ) then
						TargetStats.Stats[Stat] = TargetStats.Stats[Stat].."%"
					end
					if ( Stat == "Crit" ) then
						TargetStats.Stats[Stat] = TargetStats.Stats[Stat].."%"
					end
					if ( Stat == "Hit" ) then
						TargetStats.Stats[Stat] = TargetStats.Stats[Stat].."%"
					end
					if ( Stat == "Exprate" ) then
						TargetStats.Stats[Stat] = TargetStats.Stats[Stat].."%"
					end
					if ( Stat == "Mastery" ) or ( Stat == "Masteryrating" ) then
						TargetStats.Stats[Stat] = TargetStats.Stats[Stat].."%"
					end
					if ( Add == true ) then
						--GameTooltip:AddDoubleLine( Stat..": ", TargetStats.Stats[Stat] )
					end
					StatsFilled = StatsFilled + 1
				end
			end
			AGCLocal[Navnet].TargetStats = TargetStats
			Statbudget = math.floor( Statbudget )
			if ( AGCLocal[Navnet].Statbudget == nil ) or ( Statbudget > AGCLocal[Navnet].Statbudget ) then
				AGCLocal[Navnet].Statbudget = Statbudget
			end
			local Prcnt = math.floor( (Statbudget / AGCLocal[Navnet].Statbudget)*100 )
			GameTooltip:AddDoubleLine( "Stat budget: ", Statbudget.."("..Prcnt.."%)" )
			if ( Resilience > 0 ) then
				GameTooltip:AddDoubleLine( "Resilience found!", Resilience.." res." )
			end
			if ( StatsFilled > 0 ) then
				StatsFilled = math.floor((StatsFilled / StatTypes)*100)
			end
			StatsFilled = StatsFilled.."%"--egentlig ubrukelig, siden feks en rogue bruker ikke int, spirit og sp, og en priest bruker ikke agi, str, ap eller arp
		end
	else
		--GameTooltip:AddDoubleLine( "AGC did not find AUEC:", AGCLocal[Navnet].TargetStats )
	end
end

function AGCLocal:GetStatValue( Statname )
	if ( Statname == "Armor" ) then
		return 0
	elseif ( Statname == "Stamina" ) then
		return 1
	elseif ( Statname == "Masteryrating" ) or ( Statname == "Mastery" ) then
		return 1
	elseif ( Statname == "MP5" ) then
		return 2
	elseif ( Statname == "SP" ) then
		return 0.9
	elseif ( Statname == "Mana" ) then
		return 0
	elseif ( Statname == "Haste" ) then
		return 1
	elseif ( Statname == "Crit" ) then
		return 1
	elseif ( Statname == "Hit" ) then
		return 1
	elseif ( Statname == "Exprate" ) then
		return 1
	elseif ( Statname == "Wpn_Main" ) then
		return 1
	elseif ( Statname == "Wpn_Off" ) then
		return 1
	elseif ( Statname == "Wpn_Ranged" ) then
		return 1
	elseif ( Statname == "Wpn_Main_Speed" ) then
		return 0
	elseif ( Statname == "Wpn_Off_Speed" ) then
		return 0
	elseif ( Statname == "Wpn_Ranged_Speed" ) then
		return 0
	elseif ( Statname == "Strength" ) then
		return 1
	elseif ( Statname == "Agility" ) then
		return 1
	elseif ( Statname == "AP" ) then
		return 0.5
	elseif ( Statname == "Intellect" ) then
		return 1
	elseif ( Statname == "ARP" ) then
		return 1
	elseif ( Statname == "Spirit" ) then
		return 1
	elseif ( Statname == "Socket" ) then
		return 40
	--elseif ( Stat == "CatAP" ) then
	elseif ( Statname == "Bonusdps" ) then
		return 1
	elseif ( Statname == "Resilience" ) then
		return 0
	--elseif ( Stat == "EnergyRegenPerSec" ) then
	else
		print( "AGC statcheck 257: Stat not recognized:", Statname )
		return 0
	end
end

function AGCLocal:TalentQuery_Ready(e, name, realm, unitid)
	if ( AUE ) then
		local isnotplayer = not UnitIsUnit(unitid, "player")
		local spec = {}
		if ( AUEC.SavedSpeccs == nil ) then
			AUEC.SavedSpeccs = {}
		end
		AUEC.SavedSpeccs[name] = {}
		AUEC.SavedSpeccs[name].Tree = {}
		for tab = 1, GetNumTalentTabs(isnotplayer) do
			local treename, _, pointsspent = GetTalentTabInfo(tab, isnotplayer)
			tinsert(spec, pointsspent)
			AUEC.SavedSpeccs[name].Tree[tab] = {}
			AUEC.SavedSpeccs[name].Tree[tab].Talent = {}
			for Talent = 1, GetNumTalents(tab) do
				local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo( tab ,Talent, isnotplayer );
				AUEC.SavedSpeccs[name].Tree[tab].Talent[Talent] = currRank
			end
		end
		_G.RaidTalents[UnitGUID(unitid)] = spec
	end
end